
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【C语言】指向一维数组元素的指针 / 憋错料</title>

    <meta name="description" content="【C语言】指向一维数组元素的指针 本文目录 一.用指针指向一维数组的元素 二.用指针遍历数组元素 三.指针与数组的总结 四.数组.指针与函数参数 前面我们已经学习了指针,如果指针存储了某个变量的地址,我们就可以说指针指向这个变量.数组及其数组元素都占有存储空间,都有自己的地址,因此指针变量可以指向整个数组,也可以指向数组元素. 回到顶部 一.用指针指向一维数组的元素 1 // 定义一个int类型的数组 2 int a[2]; 3 4 // 定义一个int类型的指针 5 int *p; 6 7 // 让指针指向数组的第0个元素 8">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">【C语言】指向一维数组元素的指针</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1><strong>本文目录</strong></h1>
<ul>
<li><a href="http://www.cnblogs.com/mjios/archive/2013/03/18/2964748.html#label0" rel="external nofollow noreferrer">一、用指针指向一维数组的元素</a></li>
<li><a href="http://www.cnblogs.com/mjios/archive/2013/03/18/2964748.html#label1" rel="external nofollow noreferrer">二、用指针遍历数组元素</a></li>
<li><a href="http://www.cnblogs.com/mjios/archive/2013/03/18/2964748.html#label2" rel="external nofollow noreferrer">三、指针与数组的总结</a></li>
<li><a href="http://www.cnblogs.com/mjios/archive/2013/03/18/2964748.html#label3" rel="external nofollow noreferrer">四、数组、指针与函数参数</a></li>
</ul>
<p>前面我们已经学习了指针，如果指针存储了某个变量的地址，我们就可以说指针指向这个变量。数组及其数组元素都占有存储空间，都有自己的地址，因此指针变量可以指向整个数组，也可以指向数组元素。</p>
<p><a href="http://www.cnblogs.com/mjios/archive/2013/03/18/2964748.html#labelTop" rel="external nofollow noreferrer">回到顶部</a></p>
<h2>一、用指针指向一维数组的元素</h2>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1 // 定义一个int类型的数组
 2 int a[2];
 3
 4 // 定义一个int类型的指针
 5 int *p;
 6
 7 // 让指针指向数组的第0个元素
 8 p = &amp;a[0];
 9
10 // 修改所指向元素的值
11 *p = 10;
12
13 // 打印第一个元素的值
14 printf("a[0] = %d", a[0]);</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>输出结果：<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ5NzI3OS8yMDEzMDMvMTcxODA2NTMtNjRmZmQwZjZkZmI1NDBjYjliYzFiNjc5MTI0N2JjNmMucG5n.jpg" />，说明已经通过指针间接修改了数组元素的值，跟指向一个普通int类型变量是一样的。</p>
<p>由于数组名代表着数组的首地址，即a == &amp;a[0]，因此第8行代码等价于：</p>
<pre>// 让指针指向数组的第0个元素
p = a;</pre>
<p>内存分析图如下，一个指针变量占用2个字节，一个int类型的数组元素占用2个字节</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ5NzI3OS8yMDEzMDMvMTcxODE2NDUtMTBhZjAwNjk1YzYzNGZkNGE0MGFlNDIyZWUzNDgzMmQucG5n.jpg" /></p>
<p><a href="http://www.cnblogs.com/mjios/archive/2013/03/18/2964748.html#labelTop" rel="external nofollow noreferrer">回到顶部</a></p>
<h2>二、用指针遍历数组元素</h2>
<h3>1.最普通的遍历方式是用数组下标来遍历元素</h3>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre>1 // 定义一个int类型的数组
2 int a[4] = {1, 2, 3, 4};
3
4 int i;
5 for (i = 0; i &lt; 4; i++) {
6     printf("a[%d] = %d \n", i, a[i]);
7 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>输出结果：<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ5NzI3OS8yMDEzMDMvMTcyMjA1MDYtZDA5ODliZmVkNmY3NDg1Yjg2ZGQ2M2IzZjJhMmQ2ZGUucG5n.jpg" /></p>
<h3>2.接下来我们用指针来遍历数组元素</h3>
<p>先定义一个指针，指向数组的第一个元素</p>
<pre>// 定义一个int类型的数组
int a[4] = {1, 2, 3, 4};

// 定义一个int类型的指针，并指向数组的第0个元素
int *p = a;</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ5NzI3OS8yMDEzMDMvMTcyMjEyMzUtYTVmOTdlMDQwNjNmNGEyNWJlZjIyMjM5YmIyZWFkOTAucG5n.jpg" /></p>
<p>p的值是a[0]的地址，因此，现在我们利用指针 p只能访问数组的第0个元素a[0]，用*p就可取出a[0]的值1。要想访问其他元素，就必须拿到元素的地址，可以发现每个元素的地址差值为2，因为在 16位编译器环境下，一个int类型的变量占用2个字节。现在只是知道a[0]的地址值为p，怎么根据a[0]的地址获取其他元素的地址呢？其实非常简 单，p+1就是a[1]的地址。注意了，这里的p+1代表着p的值加2，并不是p的值加1，比如p的值为ffc3，p+1则为ffc5，而非ffc4。依 次类推，p+2就是a[2]的地址ffc7，p+3就是a[3]的地址ffc9。</p>
<h4>我先解释一下，为什么p+1代表p的值加2，而不是加1呢？</h4>
<p>其实，p+1不一定代表p的值加2，也可能是加1、加4或者加8。究竟加多少，这跟指针的类型有关。下图是在16位编译器环境下的情况。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ5NzI3OS8yMDEzMDMvMTcyMjQ0MzctYTIzYjQ4YTJjN2U2NDRjZmJlNGMzODAwYWY1YmY2ZjgucG5n.jpg" /></p>
<p>聪明的你可能已经找到规律了，因为char类型的变量要占用1字节，所以p+1代表p的值加1；float类型的变量占用4字节，所以p+1代表p的值加4。从这一点，也可以很好地说明为什么指针一定要分类型，不同类型的指针，p+1的含义是不一样的。</p>
<p>上述代码中的p指向了int类型的数组元素a[0]，所以p+1代表p的值加2。知道怎么获取其他元素的地址了，那么就可以利用指针p遍历数组元素了。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1 // 定义一个int类型的数组
 2 int a[4] = {1, 2, 3, 4};
 3
 4 // 定义一个int类型的指针，并指向数组的第0个元素
 5 int *p = a;
 6
 7 int i;
 8 for (i = 0; i &lt; 4; i++) {
 9     // 利用指针运算符*取出数组元素的值
10     int value = *(p+i);
11
12     printf("a[%d] = %d \n", i, value);
13 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>注意第10行的代码，*(p+i)代表根据p+i的值(其实就是第i个数组元素的地址)访问对应的存储空间，并取出存储的内容(也就是取出第i个数组元素的值)，赋值给左边的value。</p>
<p>最后的输出效果是一样的：<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ5NzI3OS8yMDEzMDMvMTcyMjA1MDYtZDA5ODliZmVkNmY3NDg1Yjg2ZGQ2M2IzZjJhMmQ2ZGUucG5n.jpg" />。注意的是：遍历完毕后，指针变量p还是指向a[0]，因为p值一直没有变过，一直都是a[0]的地址ffc3。</p>
<p>补充一下，其实第10行改成下面的代码也是可以的：</p>
<pre>int value = *(a+i);</pre>
<p>大家都知道，a值代表数组的首地址，也就是a[0]的地址ffc3。a+1则代表a的值加2，即a[1]的地址ffc5，也就是说，a+i代表着元素a[i]的地址。相信大家也能猜出来了，a+1不一定代表着a值加2，究竟加多少，取决于数组的类型。a+i的计算方法与p+i相同。</p>
<p>利用上面的方法遍历完数组元素后，p一直指向元素a[0]。其实我们也可以直接修改p的值来访问数组元素，只需要改一下第10行的代码即可</p>
<pre>// 利用指针运算符*取出数组元素的值
int value = *(p++);</pre>
<p>p++其实就是相当于p = p + 1，直接修改了p值，而且每次是加2。因此，每执行一次p++，指针p就会指向下一个数组元素。</p>
<p>输出结果肯定是一样的：<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ5NzI3OS8yMDEzMDMvMTcyMjA1MDYtZDA5ODliZmVkNmY3NDg1Yjg2ZGQ2M2IzZjJhMmQ2ZGUucG5n.jpg" />。但是，遍历完毕后，指针变量p没有指向任何数组元素，因为一共执行了4次p++，最后p值为ffcb。当然，可以重新让p指向a[0]：p = &amp;a[0];或者p = a;</p>
<p>注意，这里的写法是错误的</p>
<pre>int value = *(a++);</pre>
<p>a++相当于a=a+1，数组名a是个常量！不能进行赋值运算！</p>
<p><a href="http://www.cnblogs.com/mjios/archive/2013/03/18/2964748.html#labelTop" rel="external nofollow noreferrer">回到顶部</a></p>
<h2>三、指针与数组的总结</h2>
<p>p是指针，a是一个数组</p>
<p>1&gt; 如果p指向了一个数组元素，则p+1表示指向数组该元素的下一个元素。比如，假设p = &amp;a[0]，则p+1表示a[1]的地址</p>
<p>2&gt; 对于不同类型的数组元素，p值的改变是不同的。如果数组元素为int类型，p+1代表着p的值加上2(16位编译器环境下)</p>
<p>3&gt; 如果p的初值是&amp;a[0]，那么</p>
<ul>
<li>p+i和a+i都可以表示元素a[i]的地址，它们都指向数组的第i个元素。a代表数组首地址，a+i也是地址，它的计算方法与p+i相同</li>
<li>*(p+i)和*(a+i)都表示数组元素a[i]</li>
<li>虽然p+i和a+i都指向数组的第i个元素,但二者使用时还是有区别的。因为作为指针变量的p可以改变自身值，如p++,使p的值自增。而数组名a是一个代表数组首地址的常量，它的值是不能改变的，即a++是不合法的</li>
</ul>
<p>4&gt; 引用一个数组元素可以有两种方法:</p>
<ul>
<li>下标法: 如a[i]</li>
<li>指针法: 如*(p+i) 或 *(a+i)</li>
</ul>
<p><a href="http://www.cnblogs.com/mjios/archive/2013/03/18/2964748.html#labelTop" rel="external nofollow noreferrer">回到顶部</a></p>
<h2>四、数组、指针与函数参数</h2>
<p>1.用数组名作为函数实参时，是把实参数组的首地址传递给形参数组，两个数组共同占用同一段内存空间，这样形参数组中的元素值发生变化就会使实参数组的元素值也同时变化</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1 void change(int b[]) {
 2     b[0] = 10;
 3 }
 4
 5 int main()
 6 {
 7     // 定义一个int类型的数组
 8     int a[4] = {1, 2, 3, 4};
 9
10     // 将数组名a传入change函数中
11     change(a);
12
13     // 查看a[0]
14     printf("a[0]=%d", a[0]);
15
16     return 0;
17 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>change函数的形参是数组类型的，在第11行调用change函数时，将数组名a，也就是数组的地址传给了数组b。因此数组a和b占用着同一块内存空间。</p>
<p>输出结果：<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ5NzI3OS8yMDEzMDMvMTgwMDAzMDQtMDQ3YmYzNjRjYjkzNDkzOTg4YTFlNGYyNTk1MzllZmYucG5n.jpg" /></p>
<p>2.这种地址的传递也可以用指针来实现。函数的实参和形参都可以分别使用数组或指针。这样就有4种情况:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ5NzI3OS8yMDEzMDMvMTgwMDA3MjUtOWI1NmY0MjYzYzVmNDRjMGExNjI2MzFkN2Q2MGFlOTkucG5n.jpg" /></p>
<p>也就是说，如果一个函数的形参类型是一个数组，调用函数时，你可以传入数组名或者指针变量；</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1 void change(int b[]) {
 2     b[0] = 10;
 3 }
 4
 5 int main()
 6 {
 7     // 定义一个int类型的数组
 8     int a[4] = {1, 2, 3, 4};
 9
10     int *p = a;
11
12     // 将数组名a传入change函数中
13     change(p);
14
15     // 查看a[0]
16     printf("a[0]=%d", a[0]);
17
18     return 0;
19 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>注意第1行的形参类型是个数组int b[]，第10行定义了指针变量p，第13行将p当做实参传入函数</p>
<p>如果一个函数的形参类型是一个指针变量，调用函数时，你可以传入数组名或者指针变量。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1 void change(int *b) {
 2     b[0] = 10;
 3     // 或者*b = 10;
 4 }
 5
 6 int main()
 7 {
 8     // 定义一个int类型的数组
 9     int a[4] = {1, 2, 3, 4};
10
11     // 将数组名a传入change函数中
12     change(a);
13
14     // 查看a[0]
15     printf("a[0]=%d", a[0]);
16
17     return 0;
18 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>注意第1行的形参类型是个指针变量int *b，第12行将数组名a当做实参传入函数。</p>
<p>由第2行可以看出，在很多情况下，指针和数组是可以相互切换使用的。但是，并不能说指针就等于数组。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 00:00:32 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>【C语言】指向一维数组元素的指针的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02waPp3.html" rel="bookmark">【C语言】-指向一维数组元素的指针</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文目录 一.用指针指向一维数组的元素 二.用指针遍历数组元素 三.指针与数组的总结 四.数组.指针与函数参数 说明:这个C语言专题,是学习iOS开发的前奏.也为了让有面向对象语言开发经验的程序员,能够快速上手C语言.如果你还没有编程经验,或者对C语言.iOS开发不感兴趣,请忽略 前面我们已经学习了指针,如果指针存储了某个变量的地址,我们就可以说指针指向这个变量.数组及其数组元素都占有存储空间,都有自己的地址,因此指针变量可以指向整个数组,也可以指向数组元素. 回到顶部 一.用指针指向一维数组的			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWQGKb3.html" rel="bookmark">C语言 12-指向一维数组元素的指针</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文目录 一.用指针指向一维数组的元素 二.用指针遍历数组元素 三.指针与数组的总结 四.数组.指针与函数参数 说明:这个C语言专题,是学习iOS开发的前奏.也为了让有面向对象语言开发经验的程序员,能够快速上手C语言.如果你还没有编程经验,或者对C语言.iOS开发不感兴趣,请忽略. 前面我们已经学习了指针,如果指针存储了某个变量的地址,我们就可以说指针指向这个变量.数组及其数组元素都占有存储空间,都有自己的地址,因此指针变量可以指向整个数组,也可以指向数组元素. 一.用指针指向一维数组的元素 1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWwzkyM.html" rel="bookmark">【C语言】12-指向一维数组元素的指针</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.用指针指向一维数组的元素 1 // 定义一个int类型的数组 2 int a[2]; 3 4 // 定义一个int类型的指针 5 int *p; 6 7 // 让指针指向数组的第0个元素 8 p = &amp;a[0]; 9 10 // 修改所指向元素的值 11 *p = 10; 12 13 // 打印第一个元素的值 14 printf(&quot;a[0] = %d&quot;, a[0]); 输出结果:,说明已经通过指针间接修改了数组元素的值,跟指向一个普通int类型变量是一样的. 由于数组名代表			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgZaaN4.html" rel="bookmark">学习笔记之12-指向一维数组元素的指针</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.用指针指向一维数组的元素 1 // 定义一个int类型的数组 2 int a[2]; 3 4 // 定义一个int类型的指针 5 int *p; 6 7 // 让指针指向数组的第0个元素 8 p = &amp;a[0]; 9 10 // 修改所指向元素的值 11 *p = 10; 12 13 // 打印第一个元素的值 14 printf(&quot;a[0] = %d&quot;, a[0]); 输出结果:,说明已经通过指针间接修改了数组元素的值,跟指向一个普通int类型变量是一样的. 由于数组名代表			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49ojKg0.html" rel="bookmark">编程题：比较指向数组元素的指针变量和指向数组的指针变量的不同。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#include&lt;stdio.h&gt; void main() {int a[2][3]={1,2,3,4,5,6}; int *p1,(*p2)[3]; /*p1指向数组元素,p2指向包含3个元素的一维数组*/ p1=a[0];p2=a; /*用指向数组元素的指针变量输出二维数组元素*/ for(;p1&lt;a[0]+6;p1++) printf(&quot;%4d&quot;,*p1); printf(&quot;\n&quot;); /*用指向以为数组的指针变量输出二维数组元素*/ for			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47Y9kY0.html" rel="bookmark">指向二维数组元素的指针变量</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(1)指向数组元素的指针变量 例1.有一个3X4的二维数组,要求用指向元素的指针变量输出二维数组各元素的值. 编写程序 1 #include &lt;stdio.h&gt; 2 int main() 3 { 4 int a[3][4] = { 1,3,5,7,9,11,13,15,17,19,21,23 }; 5 int *p; 6 for (p = a[0]; p &lt; a[0] + 12; p++) //a[0]代表列指针的起点,p依次指向下一个元素 7 { 8 if ((p - a[0])%4			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02DjnB4.html" rel="bookmark">编程题：指向二维数组元素的指针变量。功能：已知二维数组a&lbrack;2&rsqb;&lbrack;3&rsqb;&comma;输入输出全部元素。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#include&lt;stdio.h&gt; void main() { int a[2][3],i,j; int *p; /*用坐标法输入二维数组元素*/ for(i=0;i&lt;2;i++) for(j=0;j&lt;3;j++) scanf(&quot;%d&quot;,&amp;a[i][j]); /*用指针法输出二维数组元素*/ p=a[0];         /*等价于p&amp;a[0][0];*/ for(;p&lt;a[0]+6;p++)   printf(&quot;%4d&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41yjBY4.html" rel="bookmark">&lbrack;C&plus;&plus;程序设计&rsqb;指向数组元素的指针</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果先使p指向数组a的首元素(即p=a),则: (1) p++(或p+=1).使p指向下一元素,即a[1]. 如果用*p,得到下一个元素a[1]的值. (2) *p++.由于++和*同优先级,结合方向为自右而 左,因此它等价于*(p++).作用是: 先得到p指向 的变量的值(即*p),然后再使p的值加1.例6.5(3)程序中最后一个for语句: for(p=a;p&lt;a+10;p++) cout&lt;&lt;*p;可以改写为for(p=a;p&lt;a+10;) cout&lt;&lt;*p++;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M61Jvr4.html" rel="bookmark">一维数组元素的输入输出方法总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.数组的下标法:直观且容易理解 如: int a[5],i; printf(&quot;Input five numbers:&quot;); for(i=0;i&lt;5;i++) {  scanf(&quot;%d&quot;,&amp;a[i]); } for(i=0;i&lt;5;i++) {     printf(&quot;%4d&quot;,a[i]); } 2.数组名首地址法(指针法):指针增1运算的执行效率很高,利用指针的增1运算实现指针的移动,省去了每寻找一个数组元素都要进行的指针算			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xR8Q4.html" rel="bookmark" class="title">Mac OSX &lpar;EI Capitan&rpar;搭建Caffe环境并配置python接口</a>
					<div>
						Caffe是一个清晰而高效的深度学习框架,其作者是博士毕业于UC Berkeley的贾扬清.Caffe是纯粹的C++/CUDA架构,支持命令行.Python和MATLAB接口:可以在CPU和GPU直接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lXKGX0.html" rel="bookmark" class="title">Hyper-V Server 2012 R2 安装</a>
					<div>
						1. 将Hyper-V Server 2012 R2的光盘插入,设置BIOS从光驱启动: 2. 设置语言和其他选项:保持默认,直接点击下一步 3. 系统安装和修改选择:安装系统,直接点击现在安装 4. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVgoq20.html" rel="bookmark" class="title">linux学习&lpar;2&rpar;文件操作</a>
					<div>
						pwd 显示当前目录 touch 创建空白文件或者更新已有文件的时间 .开头的文件为隐藏文件 列出目录内容 ls -a 显示所有文件 包括隐藏文件 ls -r 显示详细信息 ls -R 显示子目录的结 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jX59E4.html" rel="bookmark" class="title">11-28--订餐系统项目跟进</a>
					<div>
						跟进结果: 经过这几天我们组的成员反复讨论,反复修改,每个人各司其职,终于也把订餐系统的登录界面功能实现,界面虽然并不是特别美观,但后续相信会有更好的改进. 在这一功能中,我们实现用户的登录,还有用户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONlJX0.html" rel="bookmark" class="title">关于javascript面向对象之闭包</a>
					<div>
						学习javascript一段时间了,经过师傅的指引,自己对闭包作出如下总结,如有某点不妥,请君指出,不胜感激! 要理解闭包,首先必须理解Javascript特殊的变量作用域. 变量的作用域无非就是两种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5VpE0.html" rel="bookmark" class="title">Vs未能正确加载&OpenCurlyDoubleQuote;Microsoft&period;VisualStudio&period;Editor&period;Implementation&period;EditorPackage&rdquo;包</a>
					<div>
						紧接着就是vs出问题.打开vs,加载之前写的程序,但是提示: 然后就是vs2012停止运行了. 上网搜,解决问题的方法如下: (1)找到vs2012开发人员命令提示 : 在该窗口下输入“devenv  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47DnvyM.html" rel="bookmark" class="title">【转】使用命令行方式创建和启动android模拟器</a>
					<div>
						原文网址:http://blog.csdn.net/tiandinilv/article/details/8953001 1.Android模拟器介绍 Android中提供了一个模拟器来模拟ARM核的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rknW14.html" rel="bookmark" class="title">第一个 终端Java程序 （Mac）</a>
					<div>
						新建了一个存放Java工程的文件夹:java_text文件夹 在文件夹下 新建一个 文本文件 内容如下: import java.util.*; public class HelloDate { pu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xrgzD4.html" rel="bookmark" class="title">Spread   JS  随笔一 简单表格</a>
					<div>
						Spread JS 是一个在线Excel表格控件,功能非常强大.下面大概的介绍一下简单的使用. 最简单的表格 步骤 在工程文件中的head 部分引用相关的css 和js 1 &lt;head&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoaRjn3.html" rel="bookmark" class="title">消除编译告警&mdash;&mdash;warning&colon; no previous prototype for</a>
					<div>
						方法一:如果告警函数只在文件内部使用,在函数前面添加static即可消除告警: static void foo() {} 方法二:如果告警函数在其他文件被调用,则函数定义文件使用include包含函数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQdk8M.html" rel="bookmark" class="title">PHP去除BOM头的方法</a>
					<div>
						BOM头是UTF-8来告诉编辑器:我是UTF8编码.它的编码是\xEF\xBB\xBF 但是PHP在设计之初并没有考虑到BOM头的问题,所以在编解码的时候很容易出现问题 比如今天遇到的问题,json_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPZx513.html" rel="bookmark" class="title">2、部门与项目人员组成 - 部门管理经验谈</a>
					<div>
						在部门的管理中,首要的是部门的组成和部门人员的组成,这个是整个部门进行规划和开展工作的基本点.笔者在进行部门管理的过程中,部门人员安排有限,这里仅根据笔者以前去过的公司的一些情况进行描述. 一.部门的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eEbap0.html" rel="bookmark" class="title">MVC3中 ViewBag、ViewData和TempData的使用和区别（转发：汴蓝）</a>
					<div>
						MVC3中 ViewBag.ViewData和TempData的使用和区别 在MVC3开始,视图数据可以通过ViewBag属性访问,在MVC2中则是使用ViewData.MVC3中保留了ViewDat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0b5gOYM.html" rel="bookmark" class="title">Linux配置SSH公钥认证与Jenkins远程登录进行自动发布</a>
					<div>
						公钥认证,是使用一对加密字符串,一个称为公钥(public key), 任何人都可以看到其内容,用于加密:另一个称为密钥(private key),只有拥有者才能看到,用于解密. 在使用jenkins ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wBZ9l0.html" rel="bookmark" class="title">CentOS 6&period;3下配置LVM（逻辑卷管理</a>
					<div>
						CentOS 6.3下配置LVM(逻辑卷管理) 一.简介 LVM是逻辑盘卷管理(Logical Volume Manager)的简称,它是Linux环境下对磁盘分区进行管理的一种机制,LVM是建立在硬 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6Odg0.html" rel="bookmark" class="title">设计模型MVC和JavaBean</a>
					<div>
						六.设计模型1和设计模型2(MVC)1.模型1:JSP+JavaBean2.模型2:MVC M:Model模型 JavaBean V:视图 JSP C:控制器 Servlet 七.模型1开发一个简单的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPqnqM.html" rel="bookmark" class="title">Android实战简易教程-第四十一枪（显示倒计时的Button-适用于获取验证码）</a>
					<div>
						近期在做获取验证码的功能.考虑到优良的用户体验,决定制作一个拥有倒计时提示的Button按钮,在网上查了一些资料,非常是简单的就能实现.我写了一个小Demo,大家能够应用到自己的项目中. 一.代码 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzkYdJ0.html" rel="bookmark" class="title">动态参数与静态参数的判断、修改</a>
					<div>
						视图 v$parameter 中 ISSYS_MODIFIABLE 列能够查看参数属性,ISSYS_MODIFIABLE ='IMMEDIATE'为动态参数. ISSYS_MODIFIABLE ='F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyoVbn3.html" rel="bookmark" class="title">bdev文件系统</a>
					<div>
						文件系统,是对磁盘数据进行组织和管理的一种机制. 可通过装载,以目录和文件的形式向用户层呈现.但,文件和目录其实只是文件系统的前端而已,只是文件系统的用户视图,其本质还在于这样的一个数据结构:inod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZaajJ0.html" rel="bookmark" class="title">ZOJ 3631 Watashi&amp;&num;39&semi;s BG（dp&plus;dfs）</a>
					<div>
						题意:一共要吃n顿饭 公款m元 如果公款大于等于饭局所需费用 就全用公款 如果小于就自费 求最后能用的公款为多少 思路: dfs(i - 1, val + dp[i]); dfs(i - 1, val ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
